import Confirmation from "../components/top-level/confirmation";
import { useLocation, useNavigate } from "react-router-dom";
import { useEffect, useState } from "react";
import { useAppContext } from "../_context";

export function _Confirmation() {
  const [count, setCount] = useState(0);
  const [reservedseat, setReservedSeat] = useState([]);
  let { GetSeatById } = useAppContext();
  const navigate = useNavigate();
  const location = useLocation();
  useEffect(() => {
    getSeatById();
  }, []);
  const getSeatById = async () => {
    if (location?.state?.seats.length) {
      setCount(location.state.seats.length);
      setReservedSeat(location.state.seats);
    } else {
      const userid = sessionStorage.getItem("userId");
      const userseats = await GetSeatById(userid);
      setCount(userseats.seats.length);
      setReservedSeat(userseats.seats);
    }
  };

  const handleModify = (e) => {
    e.preventDefault();
    navigate("/booking");
  };

  return (
    <Confirmation
      seatCount={count}
      seats={reservedseat}
      onEdit={handleModify}
    />
  );
}
