import { useEffect, useState } from "react";
import { useAppContext } from "../_context";
import Login from "../components/top-level/login";
import { useNavigate } from "react-router-dom";
export function _Login() {
  const navigate = useNavigate();

  const { userseats, LoginOrRegister, GetAllSeats } = useAppContext();
  const [isLogged, setIsLogged] = useState(false);
  useEffect(() => {
    sessionStorage.clear();
  }, []);

  useEffect(() => {
    isLogged && handleSeats();
  }, [isLogged]);

  const handleLogin = async ({ mobile }) => {
    //get all seats and then login
    const users = await LoginOrRegister({ mobile });
    sessionStorage.setItem("userId", users?.id);

    await GetAllSeats();
    setIsLogged(true);
  };
  const handleSeats = async () => {
    const id = sessionStorage.getItem("userId");
    const userReservedSeats = userseats.filter((e) => e.id == id);
    if (!userReservedSeats.length) {
      navigate("/seat-limit");
    } else {
      sessionStorage.setItem("seatLimit", userReservedSeats[0].seats.length);
      navigate("/booking", { state: { seats: userseats } });
    }
  };

  return <Login onSubmit={handleLogin} />;
}
